using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using Advantech.Motion;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using ProductionControl.UI.PropExtend;
using static ProductionControl.UI.UIAxis;

namespace ProductionControl.UI
{
    //[TypeConverter(typeof(PropertySorter))] //此属性使类无法序列化和反序列化
    public class IOCardProp
    {
        public IOCardProp(string deviceNum) {
            DeviceNum = deviceNum;
        }

        [PropertyOrder(1), Browsable(true), Category("设备"), DisplayName("设备号"), Description("设备号"), ReadOnly(true), JsonIgnore]
        public string DeviceNum { get;private set; } 

        //
        [PropertyOrder(11), Browsable(true), Category("DI"), DisplayName("输入"), Description("输入"), ReadOnly(true), JsonIgnore]
        public byte[] IN { get; set; }
        [PropertyOrder(12), Browsable(true), Category("DO"), DisplayName("输出"), Description("输出")]
        public byte[] OUT { get; set; }
       
         
        /// <summary>
        /// 序列化
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public string serialize()
        {  
            return JsonConvert.SerializeObject(this);
        }
        /// <summary>
        /// 反序列化
        /// </summary>
        /// <param name="json"></param>
        /// <returns></returns>
        public void deserialize(string json)
        {
            var o=  JsonConvert.DeserializeObject<IOCardProp>(json);
            Type type = o.GetType();
            System.Reflection.PropertyInfo[] properties = type.GetProperties(); 
            foreach (System.Reflection.PropertyInfo property in properties)
            {
                string name = property.Name;
                if (!type.GetProperty(name).IsDefined(typeof(JsonIgnoreAttribute), true))
                {
                    var value = property.GetValue(o);
                    this.GetType().GetProperty(name).SetValue(this, value);
                }
            }  
        }
    }
     

}
